﻿// -=> WR-usedColors <=-
//
// Javascript for Adobe Illustrator
// by Wolfgang Reszel (ai-js@rumborak.de) 
// Russification by  S. Babanin (bebsart@gmail.com)
// Version  from 6.8.2010
// language="rus";   

// Скрипт добавляет в палитру Swatches 
// все используемые в документе цвета (по-умолчанию с опцией "global") и градиентные заливки. 
// Gradient mesh не поддерживается, поскольку javascript не имеет к ним доступа. 
// Можно дополнительно настроить обработку градиентов: (var add_gradient_colors по умолчанию ="yes")
// По умолчанию цвета добавляются как глобальные (var add_as_global по умолчанию ="yes").


var ask="yes";                                  // yes/no
var add_gradient_colors="yes";         // add colors of gradients
var add_gradients="yes";                 // Add gradients swatches
var add_textcolours="yes";              // Add colors of textobjects
var add_as_global="yes";               // Add the colors as global colors
var progressbar_limit = 200;          // Number of objects when the progress-
                                                    // will be shown

// -------------------------------------------------------------------

var WR="UsedColors\n\n";

    var MSG_ask = WR+"Добавить все используемые цвета в палитру?";
    var MSG_noobjects = WR+"Документ не содержит объектов.";
    var MSG_nodocs = WR+"У вас нет открытого документа."
    var MSG_statusOK = " Образцы цветов добавлены в палитру!"
    var txt_gray = "K";
    var txt_red = "Red";
    var txt_magenta = "Magenta";
    var txt_yellow = "Yellow";
    var txt_green = "Green";
    var txt_blue = "Blue";
    var txt_cyan = "Cyan";
    var txt_black = "Black";
    var txt_white = "White";
var processedItems=0;
var error=0;
if (documents.length<1 && error == 0) {
    error++;
    alert(MSG_nodocs);
}
if (error == 0) {
    var theObjects = activeDocument.pathItems;
    var amount = theObjects.length;
    if (add_textcolours == "yes") { amount += activeDocument.textFrames.length; }
    var objectNR = 0;
}

if (amount < 1 && error == 0) {
    error++;
    alert(MSG_noobjects);
}

if (error < 1) {
    if (ask=="yes") { askresult=confirm(MSG_ask+" ("+amount+")"); } else {askresult = true;}
    if (askresult) {

        var docRef = activeDocument;
        var SwatchMap = new Array();

        for (var j = 0 ; j < activeDocument.swatches.length; j++)
        {
            SwatchMap[SwatchName(activeDocument.swatches[j].color)] = activeDocument.swatches[j].name;
        }

        if (activeDocument.activeLayer.locked) { activeDocument.activeLayer.locked = false ; }
        activeDocument.selection = null;
        if (amount > progressbar_limit) {
            balken = docRef.pathItems.rectangle(docRef.height-docRef.rulerOrigin[1]-docRef.height/2,0-docRef.rulerOrigin[0],docRef.width,docRef.height/20);
            balken.selected = true;

            balken.filled = true;
            balken.stroked = false;
        }

        if (theObjects.length>0) { usedcolors(1); }

        if (activeDocument.textFrames.length>0 && add_textcolours == "yes" )
        {
            for (var h = 0 ; h < activeDocument.textFrames.length ; h++ )
            {
                theObjects = activeDocument.textFrames[h].characters;
                usedcolors(0);
                objectNR++;
            }
        }
        beep();
        if ( amount > progressbar_limit ) { balken.remove(); }
        redraw();
        alert(WR+processedItems+MSG_statusOK);}
}

function usedcolors(countIT)
{
    theItems = theObjects;

    var steps = Math.round(progressbar_limit/4);

    var grads = new Array();
    var gradCNT = 0;

    var i = 0

    while ( i < theItems.length )
    {
        theItem = theItems[i];

        if (theItem.typename == "TextRange" ) { theItem = theItems[i].characterAttributes;  }

        if (objectNR/steps == Math.round(objectNR/steps) && amount > progressbar_limit)
        {
            balken.width = docRef.width-docRef.width/(amount+1) * objectNR;
            redraw();
        }
        if (countIT == 1) { objectNR++; }

        var noAddFill = 0;
        var noAddStroke = 0;

        if ((!theItem.filled && countIT == 1) || theItem.fillColor.typename == "NoColor") { noAddFill =1 ; }
        if ((!theItem.stroked && countIT == 1) || theItem.strokeColor.typename == "NoColor") { noAddStroke =1 ; }

        if (noAddFill > 0 && noAddStroke > 0) { i++; continue; }

        if (theItem.fillColor.typename == "GradientColor" && add_gradient_colors == "yes")
        {
            for (var g = 0 ; g < theItem.fillColor.gradient.gradientStops.length ; g++)
            {
                grads[gradCNT] = theItem.fillColor.gradient.gradientStops[g];
                gradCNT++;
            }
        }

        try { if (activeDocument.swatches[SwatchName(theItem.fillColor)].name !="") { noAddFill = 1; }
        } catch (e) { }
        try { if (activeDocument.swatches[SwatchName(theItem.strokeColor)].name !="") { noAddStroke = 1; }
        } catch (e) { }
        try { if (activeDocument.swatches[SwatchMap[SwatchName(theItem.fillColor)]].name !="") { noAddFill = 2; }
        } catch (e) { }
        try { if (activeDocument.swatches[SwatchMap[SwatchName(theItem.strokeColor)]].name !="") { noAddStroke = 2; }
        } catch (e) { }
        try { if (!theItem.filled) { noAddFill = 3; }
        } catch (e) { }
        try { if (!theItem.stroked) { noAddStroke = 3; }
        } catch (e) { }

        if (noAddFill > 0 && noAddStroke > 0) { i++; continue; }

        if (add_as_global=="yes" && noAddFill==1) {theItem.fillColor = activeDocument.swatches[SwatchName(theItem.fillColor)].color; theItem.fillColor.tint=100;}
        if (add_as_global=="yes" && noAddStroke==1) {theItem.strokeColor = activeDocument.swatches[SwatchName(theItem.strokeColor)].color; theItem.strokeColor.tint=100;}
        if (add_as_global=="yes" && noAddFill==2) {theItem.fillColor = activeDocument.swatches[SwatchMap[SwatchName(theItem.fillColor)]].color; theItem.fillColor.tint=100;}
        if (add_as_global=="yes" && noAddStroke==2) {theItem.strokeColor = activeDocument.swatches[SwatchMap[SwatchName(theItem.strokeColor)]].color; theItem.strokeColor.tint=100;}

        for (var j = 0 ; j < activeDocument.swatches.length; j++)
        {

            if (theItem.fillColor.typename != "GradientColor" && noAddFill == 0 )
            {
                if (amount > progressbar_limit) { balken.fillColor = theItem.fillColor; }
                if (compareCol(theItem.fillColor,activeDocument.swatches[j].color)==1)
                {
                    if (add_as_global=="yes") {theItem.fillColor = activeDocument.swatches[j].color; theItem.fillColor.tint=100;}
                    noAddFill++ ;
                }
            } else {
                if(add_gradients != "yes") { noAddFill++; }
            }
            if (noAddStroke == 0 ) {
                if (amount > progressbar_limit) { balken.fillColor = theItem.strokeColor; }
                if (compareCol(theItem.strokeColor,activeDocument.swatches[j].color)==1)
                {
                    if (add_as_global=="yes") {theItem.strokeColor = activeDocument.swatches[j].color; theItem.strokeColor.tint=100;}
                    noAddStroke++ ;
                }
            } else { noAddStroke++ ; }

            if (noAddFill > 0 && noAddStroke > 0) { break; }

        }


        if (noAddFill == 0) {
            SW = addSwatch(theItem.fillColor);
            if (add_as_global=="yes") {theItem.fillColor = activeDocument.swatches[SW.name].color; theItem.fillColor.tint=100;}
            processedItems++;
        }
        if (noAddStroke == 0) {
            if (!compareCol(theItem.strokeColor,theItem.fillColor)) {
							SW = addSwatch(theItem.strokeColor);
							processedItems++;
						}
            if (add_as_global=="yes") {theItem.strokeColor = activeDocument.swatches[SW.name].color; theItem.strokeColor.tint=100;}
        }

        if (theItem.typename == "CompoundPathItem") { i += theItem.pathItems.length-1; }

        if (theItem.parent.typename == "CompoundPathItem") { i += theItem.parent.pathItems.length-1; }

        if (theItem.parent.parent.typename == "CompoundPathItem") { i += theItem.parent.parent.pathItems.length-1; }

        i++;

    }

    if (add_gradient_colors == "yes") {
        for (var i = 0 ; i < grads.length; i++)
        {
            var noAddGrad = 0;

            try { if( activeDocument.swatches[SwatchName(grads[i].color)].name ) { noAddGrad = 1; } }
            catch (e) { ; }

            if (noAddGrad == 0) {
                for (var j = 0 ; j < activeDocument.swatches.length; j++)
                {
                    if (compareCol(grads[i].color,activeDocument.swatches[j].color)==1) {
                       noAddGrad++ ;
                       alert("gr");
                       if (add_as_global=="yes") {grads[i].color = activeDocument.swatches[j].color;}
                    }
                }
            }
            if (noAddGrad == 0 ) {
               addSwatch(grads[i].color); processedItems++;
               if (add_as_global=="yes") {grads[i].color = activeDocument.swatches[j].color;}
            }
        }
    }
}

function SwatchName (SWobject)
{
    SWname = "";

    if (SWobject.typename == "SpotColor")
    {
        SWname = SWobject.spot.name;
    }
    if (SWobject.typename == "GradientColor")
    {
        SWname = SWobject.gradient.name;
    }
    if (SWobject.typename == "CMYKColor")
    {
        SWname = "C="+Math.round(SWobject.cyan)+" M="+Math.round(SWobject.magenta)+" Y="+Math.round(SWobject.yellow)+" K="+Math.round(SWobject.black);
    }
    if (SWobject.typename == "RGBColor")
    {
        SWname = "R="+Math.round(SWobject.red,2)+" G="+Math.round(SWobject.green,2)+" B="+Math.round(SWobject.blue);
    }
    if (SWobject.typename == "GrayColor")
    {
        SWname = txt_gray+"="+Math.round(SWobject.gray,2);
    }

    switch (SWname) {
        case "C=100 M=0 Y=0 K=0":
        SWname = txt_cyan; break;
        case "C=0 M=100 Y=0 K=0":
        SWname = txt_magenta; break;
        case "C=0 M=0 Y=100 K=0":
        SWname = txt_yellow; break;
        case "C=100 M=100 Y=0 K=0":
        SWname = txt_blue; break;
        case "C=100 M=0 Y=100 K=0":
        SWname = txt_green; break;
        case "C=0 M=100 Y=100 K=0":
        SWname = txt_red; break;
        case "C=0 M=0 Y=0 K=100":
        SWname = txt_black; break;
        case "C=0 M=0 Y=0 K=0":
        SWname = txt_white; break;
        case "R=0 G=0 B=0":
        SWname = txt_black; break;
        case "R=255 G=255 B=255":
        SWname = txt_white; break;
        case "R=255 G=0 B=0":
        SWname = txt_red; break;
        case "R=0 G=255 B=0":
        SWname = txt_green; break;
        case "R=0 G=0 B=255":
        SWname = txt_blue; break;
        case "R=255 G=255 B=0":
        SWname = txt_yellow; break;
        case "R=0 G=255 B=255":
        SWname = txt_cyan; break;
        case "R=255 G=0 B=255":
        SWname = txt_magenta; break;
        case txt_gray+"=100":
        SWname = txt_black; break;
        case txt_gray+"=0":
        SWname = txt_white; break;
    }
    return SWname;
}
function addSwatch(SWobject) {

    SWname = SwatchName(SWobject);
    if (add_as_global=="yes" && SWobject.typename != "GradientColor" && SWobject.typename != "GrayColor") {
        SW = activeDocument.spots.add();
        SW.colorType = ColorModel.PROCESS;
    } else {
        SW = activeDocument.swatches.add();
    }
    SW.name = SWname;
    SW.color = SWobject;

    return SW;
}

function compareCol (Col1, Col2)
{
    var compOK = 0;

    if (Col1.typename == Col2.typename || add_as_global == "yes") {

        Tint1 = 100;
        Tint2 = 100;

        if (Col1.typename == "SpotColor")
        {
            Tint1 = Col1.tint;

            Col1 = Col1.spot.color;
        }
        if (Col2.typename == "SpotColor")
        {
            Tint2 = Col2.tint;

            Col2 = Col2.spot.color;
        }
        if (Col1.typename == "CMYKColor")
        {
            if (Math.round(Col1.cyan*10) == Math.round(Col2.cyan*10) && Math.round(Col1.magenta*10) == Math.round(Col2.magenta*10) && Math.round(Col1.yellow*10) == Math.round(Col2.yellow*10) && Math.round(Col1.black*10) == Math.round(Col2.black*10)) { compOK = 1; }
        }
        if (Col1.typename == "RGBColor")
        {
            if (Math.round(Col1.red*10) == Math.round(Col2.red*10) && Math.round(Col1.green*10) == Math.round(Col2.green*10) && Math.round(Col1.blue*10) == Math.round(Col2.blue*10) ) { compOK = 1; }
        }
        if (Col1.typename == "GrayColor")
        {
            if (Math.round(Col1.gray*100) == Math.round(Col2.gray*100) ) { compOK = 1; }
        }

        if (compOK ==1 && Tint1 != Tint2) { compOK = 0; }

    }

    if (compOK == 1 ) { return 1; } else { return 0; }

}